public class ExceptionsDemo {
    
    public static void main(String[] args) 
    {
        // three possible scenarions when launching this pg: 
        // 1. cmd line parameter given AND it is a string containing number
        // 2. cmd line parameter given but it does not contain number
        // 3. no parameter given
            // here only in case 1
        try {
            System.out.println("i=" + readNumber(args));
            
        } catch(NumberReadException e) {
            System.out.println("Error when reading number, given=" + e.getNumberGiven());
        }
            
        System.out.println("Program finished");
    }
    
    public static int readNumber(String[] args) throws NumberReadException {
        String s = null;
        
        try {
            s = args[0];
            int i = Integer.parseInt(s);
            return i;
         
        } catch(ArrayIndexOutOfBoundsException e) {
            // here if no parameter given (case 3)
            throw new NumberReadException("Number not given", e, s); 
          
        } catch(NumberFormatException e) {
            // here if no parameter given (case 3)
            throw new NumberReadException("Invalid format", e, s); 
            
        } finally {
            System.out.println("Always here before method exits");
        }
    }
}
